package cn.iocoder.yudao.module.member.service.group;

import cn.iocoder.yudao.framework.common.enums.CommonStatusEnum;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.group.vo.*;
import cn.iocoder.yudao.module.member.controller.admin.user.vo.MemberUserListVO;
import cn.iocoder.yudao.module.member.dal.dataobject.group.MemberGroupDO;
import cn.iocoder.yudao.module.member.dal.dataobject.user.MemberUserDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 用户分组 Service 接口
 *
 * @author owen
 */
public interface MemberGroupService {

    /**
     * 创建用户分组
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createGroup(@Valid MemberGroupCreateReqVO createReqVO);

    /**
     * 更新用户分组
     *
     * @param updateReqVO 更新信息
     */
    void updateGroup(@Valid MemberGroupUpdateReqVO updateReqVO);

    /**
     * 删除用户分组
     *
     * @param id 编号
     */
    void deleteGroup(Long id);

    /**
     * 获得用户分组
     *
     * @param id 编号
     * @return 用户分组
     */
    MemberGroupDO getGroup(Long id);

    /**
     * 获得用户分组列表
     *
     * @param ids 编号
     * @return 用户分组列表
     */
    List<MemberGroupDO> getGroupList(Collection<Long> ids);

    /**
     * 获得用户分组分页
     *
     * @param pageReqVO 分页查询
     * @return 用户分组分页
     */
    PageResult<MemberGroupDO> getGroupPage(MemberGroupPageReqVO pageReqVO);

    /**
     * 获得指定状态的用户分组列表
     *
     * @param status 状态
     * @return 用户分组列表
     */
    List<MemberGroupDO> getGroupListByStatus(Integer status);

    /**
     * 获得开启状态的用户分组列表
     *
     * @return 用户分组列表
     */
    default List<MemberGroupDO> getEnableGroupList() {
        return getGroupListByStatus(CommonStatusEnum.ENABLE.getStatus());
    }

    /**
     * 小组添加成员
     *
     * @param addVO 添加参数
     */
    void addMember(MemberGroupVO addVO);

    /**
     * 获取小组所有会员
     *
     * @param vo 小组ID
     * @return 所有会员
     */
    PageResult<MemberUserVO> getMemberByGroupId(MemberGroupPageVO vo);

    List<MemberUserDO> getByGroupId(Long groupId);

    /**
     * 删除会员
     *
     * @param deleteVO 小组ID
     */
    void deleteMember(MemberGroupVO deleteVO);

    /**
     * 人员列表
     *
     * @param
     */
    PageResult<MemberUserDO> getUserList(MemberUserListVO listVO);

    Boolean checkGroupAdmin();


    List<MemberGroupDO> getGroupAdmin();
    /**
     * 获取用户所在组
     */
    String getGroupNameByUserId(Long userId);

    /**
     * 获取用户所在组
     */
    Map<Long,String> getGroupNameByUserIds(List<Long> userIds);

    void updateAdmin(MemberGroupUpdateReqVO updateReqVO);

    void setAdmin(GroupAdminReqVO vo);

    List<Long> getCarteenId(Long userId);

    /**
     * 获取用户所在组类别
     */
    Integer getGroupTypeByUserId(Long userId);

    List<Integer> getGroupTypeListByUserId(Long userId);

    Boolean judgeStoreUse(Long userId);

    Boolean judgeGroup(Long userId,Long canteenId);
}
